#pragma once
#ifndef CMPLAYER_DEF
#define CMPLAYER_DEF

#include "stdio.h"
#include "process.h"
#include "windows.h"


//רMPLAYERĿ

/*
 "mplayer -slave -quiet -ac mad -zoom movie/" + file_name + " -wid " + QString::number(widget->winId());

 -wid %d -priority abovenormal -framedrop -colorkey 0x101010 -nokeepaspect -framedrop -autosync 100 -vf screenshot
 
 seek <value> [type]

Seek to some place in the movie

0 is a relative seek of +/- <value> seconds (default).

1 is a seek to <value> % in the movie.

2 is a seek to an absolute position of <value> seconds.

뼴ʵֿܣ

process->write(seek ** 1\n);

4.

volume <value> [abs]

Increase/decrease volume or set it to <value> if [abs] is nonzero.

뼴ʵֿܣ

Process->write(volume -1\n); //С

Process->write(volume +1\n); //

5.

mute [value]

Toggle sound output muting or set it to [value] when [value] >= 0

(1 == on, 0 == off).

뼴ʵֿܣ

process->write("mute 0\n"); //

process->write("mute 1\n"); //رվ
//-------------------Դ
  MPlayer mp;
  mp.SetVerbose(VERBOSE_DBG);
  mp.SetMPlayerPath (D:\\Program\\MPlayer-1.0rc2\\MPlayer.exe);
  mp.SetMediaPath (D:\\cygwin\\1.rmvb);
  mp.Play ();
  DWORD t1 = GetTickCount();
  while (mp.GetStatus() != STATUS_PLAY) Sleep (10);
  printf ((%d ms) Video [%s] %d x %d\n, GetTickCount() - t1, mp.GetVideoFormat(), mp.GetVideoWidth(), mp.GetVideoHeight());
  mp.SetVerbose(VERBOSE_ERR);
  while (!_kbhit())
  {
    printf (Playing: %d/%d\r, mp.GetPos(), (int)mp.GetMediaLength());
    Sleep (500);
  }
  getch ();
  return 0;


mplayer -slave -quiet -input file=/tmp/cmd xxx.mpeg

*/
#define WM_MFACE (WM_USER+64)

#define LOG_MPLAYER      (0)
#define LOG_USER         (1)
#define LOG_APP          (2)

#define VERBOSE_QUIET    (3)
#define VERBOSE_ERR      (2)
#define VERBOSE_WARN     (1)
#define VERBOSE_DBG      (0)

#define LOG_DEBUG        (0)
#define LOG_WARNING      (1)
#define LOG_ERROR        (2)

#define STATUS_STOP      (0)
#define STATUS_STOPING   (1)
#define STATUS_STARTING  (2)
#define STATUS_PLAY      (3)
#define STATUS_PAUSE     (4)

#define META_MAX_NAME_LEN  31
#define META_MAX_VALUE_LEN 255
#define MAX_META           64
typedef struct _meta
{
  char name [META_MAX_NAME_LEN+1];
  char value[META_MAX_VALUE_LEN+1];
}meta;


class CMplayer
{
private:
  char m_strMPlayerPath [MAX_PATH+1];
  char m_strWorkingPath [MAX_PATH+1];
  char m_strOutParam[512];//ӵⲿָ Դļж
  char m_strMediaPath   [512];
  char m_strParam       [256];
  char m_strVout        [256];
  char m_strAout        [256];
  int  m_iVerbose;

  HANDLE m_hMPlayerProcess;
  HANDLE m_hWorkingThread;
  HANDLE m_hPipeRead;
  HANDLE m_hPipeWrite;
  HANDLE m_hNotifyWindow;
  //HANDLE m_hDisplayWindow;
  HWND m_hDisplayWindow;
  DWORD  m_dwMessage;

  // status
  volatile bool mb_threadactive;
  double m_lfMediaLength;
  int    m_iPos;
  int    m_iVolume;
  int    m_iVideoWidth;
  int    m_iVideoHeight;
  int    m_iAudioBitrate;
  double m_lfFPS;
  char   m_strVideoFormat [16];
  char   m_strAudioFormat [16];
  char   m_strVideoCodec [16];
  char   m_strAudioCodec [16];
  char   m_strDemuxer [16];
  char   m_strVersion [128];
  bool   m_bMute;
  volatile int    m_iStatus; // TODO: protect this var for multithread readwrite
  meta   m_arryMetas[MAX_META];
  int    m_iMetas;
public:
	

 void SetMPlayerPath (const char * szMplayerPath)
  {
    strncpy(m_strMPlayerPath, szMplayerPath, MAX_PATH);
  }

  void SetWorkingPath (const char * szWorkingPath)
  {
    strncpy(m_strWorkingPath, szWorkingPath, MAX_PATH);
  }

  void SetMediaPath (const char * szMediaPath)
  {
    strncpy(m_strMediaPath, szMediaPath, 512);
  }

  void SetParam (const char * szParam)
  {
    strncpy(m_strParam, szParam, 255);
  }

  void SetNotifyWindow (HANDLE hWnd, DWORD dwMessage = WM_MFACE)
  {
    m_hNotifyWindow = hWnd;
    m_dwMessage = dwMessage;
  }

  void SetDisplayWindow (/*HANDLE*/HWND hWnd)
  {
    m_hDisplayWindow = hWnd;
  }

  void SetVo(const char* szVout)
  {
    if(szVout==NULL) return;
	if(szVout[0]=='\0') return;

    memset(m_strVout,0,255);
    strncpy (m_strVout, szVout, 255);
  }

  void SetAo(const char* szAout)
  {
    if(szAout==NULL) return;
	if(szAout[0]=='\0') return;

    memset(m_strAout,0,255);
    strncpy (m_strAout, szAout, 255);
  }

  const char * GetParam ()
  {
    return m_strParam;
  }

  const char * GetMediaPath()
  {
    return m_strMediaPath;
  }

  const double GetFPS()
  {
    return m_lfFPS;
  }

  const char* GetVideoFormat()
  {
    return m_strVideoFormat;
  }

  const char* GetAudioFormat()
  {
    return m_strAudioFormat;
  }

  const char* GetVideoCodec()
  {
    return m_strVideoCodec;
  }

  const char* GetAudioCodec()
  {
    return m_strAudioCodec;
  }

  const char* GetMPlayerVersion()
  {
    return m_strVersion;
  }

  double GetMediaLength()
  {
    return m_lfMediaLength;
  }

  const int GetPos()
  {
    return m_iPos;
  }

  const int GetVideoWidth()
  {
    return m_iVideoWidth;
  }

  const int GetVideoHeight()
  {
    return m_iVideoHeight;
  }

  const int SetVerbose(int verbose)
  {
    if (verbose < VERBOSE_DBG)   verbose = VERBOSE_DBG;
    if (verbose > VERBOSE_QUIET) verbose = VERBOSE_QUIET;
    m_iVerbose = verbose;
    return m_iVerbose;
  }

  const int GetMetaCount()
  {
    return m_iMetas;
  }

  const char* GetMetaName(const int nIndex)
  {
    if (nIndex >= 0 && nIndex < m_iMetas)
    {
      return m_arryMetas[nIndex].name;
    }
    else
    {
      return NULL;
    }
  }

  const char* GetMetaValue(int nIndex)
  {
    if (nIndex >= 0 && nIndex < m_iMetas)
    {
      return m_arryMetas[nIndex].value;
    }
    else
    {
      return NULL;
    }
  }

public:
  int  Play();
  int  Stop();
  int  Pause();
  const int  Seek(const int Pos);
  int  GetVolume();
  int  SetVolume(int Volume);
  int  SetMute(int Mute);
  int  GetMute();
  int  GetTitle(char* buf, int nBuf);
  int  GetAlbum(char* buf, int nBuf);
  int  GetArtist(char* buf, int nBuf);
  int  GetComment(char* buf, int nBuf);
  int  GetGenre(char* buf, int nBuf);
  int  GetStatus() { return m_iStatus; }
  int  FullScreen();
  int  Snapshot();
  const char* GetMeta (const char* szName);
  const int  CreateSnapshots (const char * szDir, int nInterval = 60, int nCount = 0);
 

private:

  int  CreateMPlayerProcess();
  int  SendCommand (const char * szCommand);
  void Log (int who, int level, const char * message, int line, const char* file);
  void KillMPlayer ();
  void Notify (int param);
  void ResetStatus();
  int  GetMPlayerMessages();
  void ProcessMessage(const char * szMsg);
  const char* hasString(const char* szMsg, const char* style);
  static unsigned int WINAPI WorkThread(PVOID pThis);
  unsigned __int32 WorkThreadFunc();

public:
	int  SendCommandpub(const char * szCommand); 
	CMplayer(void);
	virtual ~CMplayer(void);
	// ƶٷֱ
	const int SeekPostion(const int iseekpos);
	// µĶָ
	const void SetExtParameters(const char * pstr);
};
#endif
